

    /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
    *                                                                 *
    *   ramozex 1.0, Mozilla Mail Extractor                           *
    *   Copyright  2005 Sebastian Pipping <webmaster@hartwork.org>   *
    *                                                                 *
    *   --> http://www.hartwork.org                                   *
    *                                                                 *
    *                                                                 *
    *   This source code is released under GPL.                       *
    *   See GPL.txt for details.                         2005-03-03   *
    *                                                                 *
    \* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */



#include <ctype.h>
#include <direct.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


int
main( int argc, char** argv )
{
	// USAGE
	if( ( argc < 2 ) || ( *(argv[ 1 ]) == '\0' ) )
	{
		printf( "USAGE: ramozex <mozfile>\n" );
		return 0;
	}
	char * name_file_in = argv[ 1 ];

	// Basename
	char * full_input = new char[ 256 ];
	char * basename   = new char[ 256 ];
	char * drive      = new char[ 256 ];
	char * dir        = new char[ 256 ];
	_fullpath( full_input, name_file_in, 255 );
	_splitpath( full_input, drive, dir, basename, NULL );

	// Output folder
	char * name_folder_out = new char[ strlen( full_input ) + 4 + 1 ];
	sprintf( name_folder_out, "%s%s%s_OUT", drive, dir, basename );
	_mkdir( name_folder_out );

	// Display	
	printf(
		"Input:\n  %s\n\nOutput:\n  %s\\*\n\n",
		full_input,
		name_folder_out
	);
	delete [] full_input;
	delete [] drive;
	delete [] dir;


	// .................From - Sat Nov 06 18:46:17 2004
	char * min = new char[ 36 ];
	char * max = new char[ 36 ];
	strcpy( min, "from - aaa aaa 00 00:00:00 0000" "\x0d\x0a" "\0" );
	strcpy( max, "from - zzz zzz 99 99:99:99 9999" "\x0d\x0a" "\0" );

	int pattern_length = strlen( min );
	int matched = 0;

	int * buf = new int[ pattern_length ];


	// OPEN
	FILE* fin  = fopen( name_file_in, "rb" );
	FILE* fout = NULL;
	if( fin == NULL )
	{
		printf( "ERROR: Could not open input\n" );
	
		// FREE
		delete [] basename;
		delete [] name_folder_out;
		delete [] buf;
		
		return 1;
	}

	int mail_number = 0;
	int bytes_read = 0;


	// WALK
	int next;
	char ch;
	while( ( next = fgetc( fin ) ) != EOF )
	{
		bytes_read++;
		ch = ( char )tolower( next );
		if( (min[ matched ] <= ch) && (ch <= max[ matched ]) )
		{
			buf[ matched ] = next;
			if( ++matched == pattern_length )
			{
				// Complete -> new mail starts here
				mail_number++;

				if( fout != NULL )
				{
					fflush( fout );
					fclose( fout );
				}

				char filename[ 256 ] = "";
				sprintf(
					filename, "%s\\%s_%05i.eml",
					name_folder_out,
					basename,
					mail_number
				);
				fout = fopen( filename, "wb" );

				matched = 0;

				if( mail_number == 1 )
				{
					strcpy( min, "\x0d\x0a" "from - aaa aaa 00 00:00:00 0000" "\x0d\x0a" "\0" );
					strcpy( max, "\x0d\x0a" "from - zzz zzz 99 99:99:99 9999" "\x0d\x0a" "\0" );
					pattern_length += 2;
				}
			}
		}
		else
		{
			if( matched > 0 )
			{
				// Append <next>
				buf[ matched++ ] = next;

				// Drop first
				fputc( buf[ 0 ], fout );

				for( int i = 1; i < matched; i++ )
				{
					bool match = true;
					for( int j = 0; j < matched - i; j++ )
					{
						ch = ( char )tolower( buf[ j + i ] );
						if( (min[ j ] > ch) || (ch > max[ j ]) )
						{
							match = false;
							break;
						}
					}

					if( match )
					{
						break;
					}
					else
					{
						fputc( buf[ i ], fout );
					}
				}

				int new_matched = matched - i;
				for( int k = 0; k < new_matched; k++ )
				{
					buf[ k ] = buf[ k + matched - new_matched ];
				}

				matched = new_matched;
			}
			else
			{
				fputc( next, fout );
			}
		}

	}


	// CLOSE
	if( fout != NULL)
	{
		fflush( fout );
		fclose( fout );
	}
	fclose( fin );


	if( !mail_number )
	{
		printf( "\nNo mails found." );
	}
	else
	{
		printf(
			"\n%i mail%s, %i bytes\n\n",
			mail_number,
			( ( mail_number == 1 ) ? "" : "s" ),
			bytes_read - (mail_number * pattern_length)
		);
	}
	

	// FREE
	delete [] basename;
	delete [] name_folder_out;
	delete [] buf;

	return 0;
}